/*
 * kalloc: allocate KANJI stream structure
 */

#include "kanji.h"

KSTREAM *
kalloc(id, openf, closef, getf, putf, flag)
	caddr_t id;
	int (*openf)(), (*closef)(), (*getf)(), (*putf)();
	unsigned flag;
{
	register KSTREAM *ksp;
	char *malloc();

	if ((!getf && !putf) ||
	     !(ksp = (KSTREAM *)malloc(sizeof(KSTREAM)))) return NULL;
	ksp->ks_id = id;
	ksp->ks_openf = openf;
	ksp->ks_closef = closef;
	ksp->ks_getf = getf;
	ksp->ks_putf = putf;
	KS_VALUE(ksp->ks_flag) = flag;
	ksp->ks_gstate = ksp->ks_pstate = 0;
	ksp->ks_ql = 0;
	ksp->ks_buf[0] = '\0';
	(void)(*ksp->ks_openf)(id);
	return ksp;
}
