/*
 * converts Shift-JIS 2-byte code to JIS 2-byte code
 * returns 0 on successful completion
 *         1 if error
 */

int
stoj(s, j)
	int *s, *j;
{
	register int sh = ((*s >> 8) & 0377), sl = (*s & 0377);
	register int jh, jl;

	jh = ((sh - ((sh >= 0xa0)? 0xc1: 0x81)) << 1)+0x21;
	if (sl >= 0x9f) {
		jh++;
		jl = sl - 0x7e;
	} else {
		jl = sl - ((sl <= 0x7e) ? 0x1f : 0x20);
	}
	*j = (jh << 8) | jl;
	return 0;
}
